from typing import Dict, List, TypedDict, Union


class InstanceCustomize(TypedDict):
    tutor: dict
    grove: dict


class ThemeStaticFiles(TypedDict):
    dest: str
    url: str


class Theme(TypedDict):
    COMPREHENSIVE_THEME_NAME: str
    COMPREHENSIVE_THEME_SOURCE_REPO: str
    COMPREHENSIVE_THEME_VERSION: str
    ENABLE_SIMPLE_THEME_SCSS_OVERRIDES: bool
    SIMPLE_THEME_SCSS_OVERRIDES: Dict[str, str]
    SIMPLE_THEME_STATIC_FILES_URLS: List[ThemeStaticFiles]
    DEFAULT: bool


class ImageBuildConfig(TypedDict):
    DOCKER_IMAGE_VAR: str


class ClusterConfigVariables(TypedDict):
    TF_VAR_cluster_domain: str
    TF_VAR_cluster_provider: str


class ClusterConfig(TypedDict):
    variables: ClusterConfigVariables


class GroveConfig(TypedDict):
    ARCHIVED: bool
    THEMES: List[Theme]
    IMAGE_BUILD_CONFIG: Dict[str, ImageBuildConfig]
    PRIVATE_SSH_KEY: str
    OPENEDX_PRIVATE_REQUIREMENTS: List[str]
    PR_WATCHER: dict


class TutorEnv(TypedDict):
    TUTOR_ID: str
    TUTOR_ROOT: str
    TUTOR_K8S_NAMESPACE: str
    TUTOR_OPENEDX_SECRET_KEY: str

    TUTOR_MYSQL_HOST: str
    TUTOR_MYSQL_PORT: str
    TUTOR_MYSQL_ROOT_USERNAME: str
    TUTOR_MYSQL_ROOT_PASSWORD: str
    TUTOR_OPENEDX_MYSQL_USERNAME: str
    TUTOR_OPENEDX_MYSQL_DATABASE: str

    TUTOR_REDIS_HOST: str
    TUTOR_REDIS_PORT: str
    TUTOR_REDIS_USERNAME: str
    TUTOR_REDIS_PASSWORD: str

    TUTOR_MONGODB_HOST: str
    TUTOR_MONGODB_DATABASE: str
    TUTOR_MONGODB_USERNAME: str
    TUTOR_MONGODB_PASSWORD: str
    TUTOR_FORUM_MONGODB_DATABASE: str

    TUTOR_OPENEDX_AWS_ACCESS_KEY: str
    TUTOR_OPENEDX_AWS_SECRET_ACCESS_KEY: str
    TUTOR_S3_HOST: str
    TUTOR_S3_STORAGE_BUCKET: str
    TUTOR_S3_REGION: str

    TUTOR_GROVE_OVERRIDE_GLOBAL_PREFIX: str
    TUTOR_GROVE_MONGODB_REPLICA_SET: str
    TUTOR_GROVE_COMPREHENSIVE_THEME_BRAND_PACKAGE_NAME: str

    TUTOR_GROVE_WAFFLE_FLAGS: List[dict]

    # Additional settings
    TUTOR_GROVE_COMMON_ENV_FEATURES: str
    TUTOR_GROVE_COMMON_SETTINGS: str

    TUTOR_GROVE_LMS_ENV: str
    TUTOR_GROVE_LMS_ENV_FEATURES: str

    TUTOR_GROVE_CMS_ENV: str
    TUTOR_GROVE_CMS_ENV_FEATURES: str
    TUTOR_GROVE_OPENEDX_AUTH: str

    # Grove autoscaling configuration
    TUTOR_GROVE_CMS_AUTOSCALING: bool
    TUTOR_GROVE_CMS_AVG_CPU: Union[int, float, str]
    TUTOR_GROVE_CMS_AVG_MEMORY: str
    TUTOR_GROVE_CMS_CPU_LIMIT: Union[int, float, str]
    TUTOR_GROVE_CMS_CPU_REQUEST: Union[int, float, str]
    TUTOR_GROVE_CMS_MAX_REPLICAS: int
    TUTOR_GROVE_CMS_MEMORY_LIMIT: str
    TUTOR_GROVE_CMS_MIN_REPLICAS: int
    TUTOR_GROVE_CMS_WORKER_AUTOSCALING: bool
    TUTOR_GROVE_CMS_WORKER_AVG_CPU: int
    TUTOR_GROVE_CMS_WORKER_AVG_MEMORY: str
    TUTOR_GROVE_CMS_WORKER_CPU_LIMIT: Union[int, float]
    TUTOR_GROVE_CMS_WORKER_CPU_REQUEST: Union[int, float]
    TUTOR_GROVE_CMS_WORKER_MAX_REPLICAS: int
    TUTOR_GROVE_CMS_WORKER_MEMORY_LIMIT: str
    TUTOR_GROVE_CMS_WORKER_MEMORY_REQUEST: str
    TUTOR_GROVE_CMS_WORKER_MIN_REPLICAS: int
    TUTOR_GROVE_LMS_AUTOSCALING: bool
    TUTOR_GROVE_LMS_AVG_CPU: int
    TUTOR_GROVE_LMS_AVG_MEMORY: str
    TUTOR_GROVE_LMS_CPU_LIMIT: Union[int, float]
    TUTOR_GROVE_LMS_CPU_REQUEST: Union[int, float]
    TUTOR_GROVE_LMS_MAX_REPLICAS: int
    TUTOR_GROVE_LMS_MEMORY_LIMIT: str
    TUTOR_GROVE_LMS_MIN_REPLICAS: int
    TUTOR_GROVE_LMS_WORKER_AUTOSCALING: bool
    TUTOR_GROVE_LMS_WORKER_AVG_CPU: int
    TUTOR_GROVE_LMS_WORKER_AVG_MEMORY: str
    TUTOR_GROVE_LMS_WORKER_CPU_LIMIT: Union[int, float]
    TUTOR_GROVE_LMS_WORKER_CPU_REQUEST: Union[int, float]
    TUTOR_GROVE_LMS_WORKER_MAX_REPLICAS: int
    TUTOR_GROVE_LMS_WORKER_MEMORY_LIMIT: str
    TUTOR_GROVE_LMS_WORKER_MEMORY_REQUEST: str
    TUTOR_GROVE_LMS_WORKER_MIN_REPLICAS: int
